# -*- coding: utf-8 -*-

from .collections import (
    Pool,
    PriorityQueue,
    Dict, Dict as Dictionary,
    NormalizeDict,
    idict, idict as IDict, idict as Idict, idict as iDict,
    AppendList,
    SortedList, SortedList as OrderedList,
    ListIterator,
    Trie,
    Namespace,
    ContextNamespace,
    HotSet,
    Stack,
    DictTree,
    OrderedSet,
)
from .command import (
    SimpleCommand,
    Command,
    Command as AsyncCommand, # DEPRECATED, use Command instead
    ModuleCommand,
    FileCommand,
)
from .config import (
    Environ,
    Config,
    Settings,
    MultiSettings,
)
from .copy import (
    Deepcopy,
)
from .csv import (
    CSVRow,
    CSVRowDict,
    CSV,
    TempCSV,
)
from .datetime import (
    Datetime,
)
from .decorators import (
    Decorator,
    InstanceDecorator,
    ClassDecorator,
    FuncDecorator,
    property,
    cachedproperty, cachedproperty as cached_property,
    classproperty,
    method,
    instancemethod,
    classmethod,
    staticmethod,
    cache, cache as cached_method, cache as once,
    deprecated,
)
from .email import (
    Email,
)
from .enum import (
    Enum,
)
from .event import (
    Event,
)
from .filetypes import (
    HTMLCleaner,
    HTMLParser,
    HTML,
    HTMLTokenizer,
    UnlinkedTagTokenizer,
    TOML,
)
from .http import (
    HTTPHeaders,
    HTTPEnviron,
    HTTPClient,
)
from .logging import (
    LogMixin,
)
from .number import (
    Binary,
    Boolean, Boolean as Bool,
    Hex,
    Integer, Integer as Int,
    Exponential,
    Partitions,
    Shorten,
)
from .parse import (
    ArgvParser,
    ArgParser,
    Version,
)
from .path import (
    Path,
    Filepath,
    Dirpath,
    Imagepath,
    TempFilepath, Filetemp,
    TempDirpath, Dirtemp,
    Cachepath,
    Sentinel,
    UrlFilepath,
    SitePackagesDirpath,
)
from .profile import (
    Profiler,
    AggregateProfiler, AggregateProfiler as AProfiler
)
from .reflection import (
    ClassFinder,
    ClasspathFinder,
    Extend,
    OrderedSubclasses,
    ReflectCallable,
    ReflectClass,
    ReflectModule,
    ReflectName,
    ReflectPath,
    ReflectType,
)
from .server import (
    CallbackServer,
    PathServer,
    ServerThread,
    ThreadingWSGIServer,
    WSGIServer,
)
from .string import (
    String, String as Str,
    ByteString, ByteString as Bytes,
    Base64,
    NamingConvention,
    EnglishWord,
    Password,
)
from .token import (
    # we don't import Token because it's too generic for toplevel, if you need
    # it then import it directly from the submodule
    Tokenizer,
    Scanner,
    WordTokenizer,
    StopWordTokenizer,
    ABNFParser,
    ABNFGrammar,
)
from .url import (
    Url,
    Host, Host as ServerAddress,
    Slug,
)
from .utils import (
    cball,
    cbany,
    make_dict,
    make_list,
    Singleton,
    infer_type,
)


__version__ = "0.20.0"

